diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index e4379a2b9..3ce6bd769 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -200,19 +200,14 @@ public class BlockLogicStairs extends BlockLogic {
         return false;
     }
 
-    @Override
-    public boolean canPlaceOnSurfaceOnCondition(@NotNull World world, @NotNull TilePosc tilePos) {
-        return (world.getBlockData(tilePos) & MASK_ROTATION_VERTICAL) != 0;
-    }
-
     @Override
     public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
         int hRot = meta & MASK_ROTATION_HORIZONTAL;
         if ((meta & MASK_ROTATION_VERTICAL) != 0) {
-            return upperStairsSupportMapping[side.getId() * 4 + hRot];
+            return upperStairsSupportMapping[side.id * 4 + hRot];
         } else {
-            return lowerStairsSupportMapping[side.getId() * 4 + hRot];
+            return lowerStairsSupportMapping[side.id * 4 + hRot];
         }
     }
 
@@ -340,7 +335,7 @@ public class BlockLogicStairs extends BlockLogic {
     public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos) & 0xF0;
 
-        Direction hRotation = mob.getHorizontalPlacementDirection(side).getOpposite();
+        Direction hRotation = mob.getHorizontalPlacementDirection(side).opposite();
         if (hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
         if (hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
         if (hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
@@ -357,16 +352,16 @@ public class BlockLogicStairs extends BlockLogic {
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos) & 0xF0;
 
-        side = side.getOpposite();
+        side = side.opposite();
         Side hSide = !side.isHorizontal() ? Side.NORTH : side;
-        Direction hRotation = hSide.getOpposite().getDirection();
+        Direction hRotation = hSide.opposite().direction();
         if (hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
         if (hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
         if (hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
         if (hRotation == Direction.WEST) meta |= H_ROTATION_WEST;
 
         Side vSide = !side.isVertical() ? Side.BOTTOM : side;
-        Direction vRotation = vSide.getDirection();
+        Direction vRotation = vSide.direction();
 //        if (vRotation == Direction.DOWN) meta |= 0b0000;
         if (vRotation == Direction.UP) meta |= MASK_ROTATION_VERTICAL;
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTimer.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTimer.java
new file mode 100644
index 000000000..21648dc61
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTimer.java
@@ -0,0 +1,214 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.entity.TileEntityTimer;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class BlockLogicTimer extends BlockLogic implements ISupportable {
+    public static final double[] torchPosOffset = {
+        -0.0625D, 0.0625D, 0.1875D, 0.3125D
+    };
+    public static final int[] tickDelayMap = {
+        4, 8, 12, 16
+    };
+
+    public static final int MASK_AXIS = 0b0000_0001;
+    public static final int AXIS_SOUTH_NORTH = 0;
+    public static final int AXIS_WEST_EAST = 1;
+
+    public static final int MASK_OUTPUT = 0b0000_0010;
+    public static final int OUTPUT_A = 0 << 1;
+    public static final int OUTPUT_B = 1 << 1;
+
+    public static final int MASK_DIRECTION = MASK_AXIS | MASK_OUTPUT;
+    public static final int DIRECTION_SOUTH = OUTPUT_A | AXIS_SOUTH_NORTH;
+    public static final int DIRECTION_WEST = OUTPUT_A | AXIS_WEST_EAST;
+    public static final int DIRECTION_NORTH = OUTPUT_B | AXIS_SOUTH_NORTH;
+    public static final int DIRECTION_EAST = OUTPUT_B | AXIS_WEST_EAST;
+
+    public static final int MASK_TICK_DELAY = 0b0000_1100;
+
+    public BlockLogicTimer(@NotNull Block<?> block) {
+        super(block, Materials.DECORATION);
+        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
+        block.withEntity(TileEntityTimer::new);
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
+    @Override
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        return this.isSupported(world, tilePos, Side.BOTTOM);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        return new ItemStack[]{new ItemStack(Items.TIMER)};
+    }
+
+    @Override
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
+        return this.isSupported(world, tilePos, Side.BOTTOM) && super.canStay(world, tilePos);
+    }
+
+    // Ensure that timers can activate doors, tnt, and other redstone components through powering a neighboring block.
+    @Override
+    public boolean isSignalSource() {
+        return true;
+    }
+
+    // Cause block updates on the target block when removing a timer,
+    // which prevents redstone components on the other wide of the target block from staying powered.
+    @Override
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        Side back = getSideFromMeta(data);
+        Side front = back.opposite();
+        world.notifyBlocksOfNeighborChange(tilePos.add(front.direction(), new TilePos()), this.block);
+    }
+
+    @Override
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return isEmittingSignal(world, tilePos, side);
+    }
+
+    @Override
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return side == getSideFromMeta(source.getBlockData(tilePos));
+    }
+
+    public static @NotNull Side getSideFromMeta(final int meta) {
+        return switch (meta & MASK_DIRECTION) {
+            case DIRECTION_SOUTH -> Side.SOUTH;
+            case DIRECTION_WEST -> Side.WEST;
+            case DIRECTION_NORTH -> Side.NORTH;
+            case DIRECTION_EAST -> Side.EAST;
+            default -> throw new RuntimeException("No side for direction " + (meta & 0b11) + "!");
+        };
+    }
+
+    @Override
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        if (!canStay(world, tilePos)) {
+            dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
+        }
+    }
+
+    @Override
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+        int metadata = world.getBlockData(tilePos);
+        int tickDelay = (metadata & MASK_TICK_DELAY) >> 2;
+        tickDelay = ((tickDelay + 1) << 2) & MASK_TICK_DELAY;
+        world.setBlockDataNotify(tilePos, tickDelay | metadata & MASK_DIRECTION);
+        return true;
+    }
+
+    @Override
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+        int metadata = world.getBlockData(tilePos);
+        int tickDelay = (metadata & MASK_TICK_DELAY) >> 2;
+        tickDelay = ((tickDelay + 1) << 2) & MASK_TICK_DELAY;
+        world.setBlockDataNotify(tilePos, tickDelay | metadata & MASK_DIRECTION);
+    }
+
+    @Override
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+        final @NotNull Axis axis = mob.getHorizontalPlacementDirection(side).axis();
+        assert(axis == Axis.X || axis == Axis.Z);
+        world.setBlockDataNotify(tilePos, axis == Axis.Z ? AXIS_SOUTH_NORTH : AXIS_WEST_EAST);
+    }
+
+    @Override
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        if (!side.isHorizontal()) side = Side.NORTH;
+        final @NotNull Axis axis = side.direction().axis();
+        assert(axis == Axis.X || axis == Axis.Z);
+        world.setBlockDataNotify(tilePos, axis == Axis.Z ? AXIS_SOUTH_NORTH : AXIS_WEST_EAST);
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        int meta = world.getBlockData(tilePos);
+        double px = (tilePos.x() + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double py = (tilePos.y() + 0.4D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double pz = (tilePos.z() + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
+
+        double xOffset = 0.0;
+        double zOffset = 0.0;
+
+        final int redstoneBrightness = 15;
+        int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
+
+        if (rand.nextInt(2) == 0) {
+            switch (getSideFromMeta(meta)) {
+                case SOUTH:
+                    zOffset = -torchPosOffset[tickDelay];
+                    break;
+                case NORTH:
+                    zOffset = torchPosOffset[tickDelay];
+                    break;
+                case EAST:
+                    xOffset = -torchPosOffset[tickDelay];
+                    break;
+                case WEST:
+                    xOffset = torchPosOffset[tickDelay];
+                    break;
+            }
+        } else {
+            switch (getSideFromMeta(meta)) {
+                case SOUTH:
+                    zOffset = torchPosOffset[tickDelay];
+                    break;
+                case NORTH:
+                    zOffset = -torchPosOffset[tickDelay];
+                    break;
+                case EAST:
+                    xOffset = torchPosOffset[tickDelay];
+                    break;
+                case WEST:
+                    xOffset = -torchPosOffset[tickDelay];
+                    break;
+            }
+        }
+        world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, 0, 0, 0, redstoneBrightness, false);
+    }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return FullSupport.INSTANCE;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index 3480259ad..540fa475e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -74,14 +74,14 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable {
 
     @Override
     public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-        if (side.isHorizontal()) side = side.getOpposite();
+        if (side.isHorizontal()) side = side.opposite();
         onPlacedOnSide(world, tilePos, side, xHit, yHit);
     }
 
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int orientation = SIDE_NONE;
-        if (side.isHorizontal()) side = side.getOpposite();
+        if (side.isHorizontal()) side = side.opposite();
         switch (side) {
             case TOP:
                 if (isSupported(world, tilePos, Side.BOTTOM)) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
index 11ee242b9..f1b94382d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
@@ -32,28 +32,12 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
         if (world.getBlockData(tilePos) == SIDE_NONE) {
             super.onPlacedByWorld(world, tilePos);
         }
-        TilePos queryPos = new TilePos();
-        if (this.torchActive) {
-            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
-        }
+        world.notifyShellBlocksInRadiusOfNeighborChange(2, tilePos, this.block);
     }
 
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
-        TilePos queryPos = new TilePos();
-        if (this.torchActive) {
-            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
-        }
+        world.notifyShellBlocksInRadiusOfNeighborChange(2, tilePos, this.block);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index a78b3754a..c9d86983b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -150,7 +150,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
 
     @Override
     public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        int meta = getMetaForDirection(player == null ? side.getDirection().getOpposite() : player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
+        int meta = getMetaForDirection(player == null ? side.direction().opposite() : player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
         if (player != null && player.getVerticalPlacementDirection(side, yHit) == Direction.UP) {
             meta = setUpperHalf(meta, true);
         }
@@ -165,7 +165,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
         if (isTrapdoorOpen(meta) && (block != null && block.getLogic() instanceof BlockLogicLadder ladder)) {
             Side ladderSide = ladder.getSideFromMeta(world.getBlockData(tilePos.down(queryPos)));
             Direction trapdoorDirection = getDirectionForMeta(meta);
-            return ladderSide.getDirection() == trapdoorDirection.getOpposite();
+            return ladderSide.direction() == trapdoorDirection.opposite();
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
index 886abf81b..ef39e7d8e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
@@ -18,22 +18,22 @@ public abstract class BlockLogicVeryRotatable
 
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
-        final @NotNull Direction direction = mob.getPlacementDirection(side).getOpposite();
+        final @NotNull Direction direction = mob.getPlacementDirection(side).opposite();
 
         world.setBlockDataNotify(tilePos, setDirection(0, direction));
     }
 
     @Override
     public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
-        world.setBlockDataNotify(tilePos, setDirection(0, side.getDirection()));
+        world.setBlockDataNotify(tilePos, setDirection(0, side.direction()));
     }
 
     public static int setDirection(final int meta, final @NotNull Direction direction) {
-        return (meta & ~MASK_DIRECTION) | (direction.getId() & MASK_DIRECTION);
+        return (meta & ~MASK_DIRECTION) | direction.id;
     }
 
     public static @NotNull Direction metaToDirection(final int meta) {
-        return Direction.getDirectionById(meta & MASK_DIRECTION);
+        return Direction.fromId(meta & MASK_DIRECTION);
     }
 
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
index 0754aeb82..3621bd2a6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
@@ -369,7 +369,7 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
 
         boolean isXConnected = posXShouldConnectTo || negXShouldConnectTo;
         boolean isZConnected = posZShouldConnectTo || negZShouldConnectTo;
-        return !isZConnected && !isXConnected && side.getAxis() != Axis.Y // Default single dust
+        return !isZConnected && !isXConnected && side.axis() != Axis.Y // Default single dust
             // When the signal request comes from a block that dust connects to (usually power sources)
             || side == Side.SOUTH && negZShouldConnectTo
             || side == Side.NORTH && posZShouldConnectTo
@@ -418,17 +418,21 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
         }
         if (block == Blocks.PUMPKIN_REDSTONE) {
             if (side == Side.NONE || side.isVertical()) return false;
-            return Side.getSideById(source.getBlockData(tilePos)).getOpposite() == side;
+            return Side.fromId(source.getBlockData(tilePos)).opposite() == side;
         }
         if (block == Blocks.MATCHER || block == Blocks.MATCHER_ACTIVE) {
-            return BlockLogicAxisAligned.metaToAxis(source.getBlockData(tilePos)) != side.getAxis();
+            return BlockLogicAxisAligned.metaToAxis(source.getBlockData(tilePos)) != side.axis();
         }
         if (block == Blocks.REPEATER_IDLE || block == Blocks.REPEATER_ACTIVE) {
             final Side direction = BlockLogicRepeater.getSideFromMeta(source.getBlockData(tilePos));
-            return side == direction || side == direction.getOpposite();
+            return side == direction || side == direction.opposite();
+        }
+        if (block == Blocks.TIMER) {
+            final Side direction = BlockLogicTimer.getSideFromMeta(source.getBlockData(tilePos));
+            return side == direction || side == direction.opposite();
         }
         if (block == Blocks.CONDUIT) {
-            return BlockLogicConduit.isSideOpen(source.getBlockData(tilePos), side.getOpposite());
+            return BlockLogicConduit.isSideOpen(source.getBlockData(tilePos), side.opposite());
         }
         return block.isSignalSource();
     }
@@ -453,7 +457,7 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
         if (side2 == Side.BOTTOM) {
             //top wire looking down at bottom
             if (side1 != Side.NONE) {
-                TilePos wallTilePos = new TilePos(tilePos).add(side1.getOpposite());
+                TilePos wallTilePos = new TilePos(tilePos).add(side1.opposite());
                 if (isBlockingConduit(worldSource, wallTilePos, side1)) return false;
 
                 //transparent diagonal connection
@@ -468,7 +472,7 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
             } else {
                 //fallback
                 for (Side fSide : new Side[]{Side.NORTH, Side.SOUTH, Side.EAST, Side.WEST}) {
-                    TilePos wallTilePos = new TilePos(tilePos).add(fSide.getOpposite());
+                    TilePos wallTilePos = new TilePos(tilePos).add(fSide.opposite());
                     if (worldSource.getBlockType(new TilePos(wallTilePos).up()) == Blocks.WIRE_REDSTONE) {
                         if (isBlockingConduit(worldSource, wallTilePos, fSide)) return false;
 
@@ -487,11 +491,11 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
             //bottom wire is looking up at top
             TilePos wallTilePos = new TilePos(tilePos).down();
             if (side1 != Side.NONE) {
-                if (isBlockingConduit(worldSource, wallTilePos, side1.getOpposite())) return false;
+                if (isBlockingConduit(worldSource, wallTilePos, side1.opposite())) return false;
 
                 //transparent diagonal connection
-                if (!isSolidWallForWire(worldSource, wallTilePos, side1.getOpposite())) {
-                    TilePos bottomWireTilePos = new TilePos(wallTilePos).add(side1.getOpposite());
+                if (!isSolidWallForWire(worldSource, wallTilePos, side1.opposite())) {
+                    TilePos bottomWireTilePos = new TilePos(wallTilePos).add(side1.opposite());
                     int bottomPower = worldSource.getBlockData(bottomWireTilePos) & MASK_POWER;
                     int topPower = worldSource.getBlockData(tilePos) & MASK_POWER;
 
@@ -546,7 +550,7 @@ public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
             return true;
         }
         if (world.getBlockType(wallTilePos) == Blocks.CONDUIT) {
-            return !BlockLogicConduit.isSideOpen(world.getBlockData(wallTilePos), directionToWall.getOpposite());
+            return !BlockLogicConduit.isSideOpen(world.getBlockData(wallTilePos), directionToWall.opposite());
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 197abfabe..0f412e6ec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -7,8 +7,7 @@ import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.piston.BlockLogicPistonBase;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.block.piston.BlockLogicPistonMoving;
-import net.minecraft.core.block.piston.BlockLogicPistonBaseSteel;
-import net.minecraft.core.block.piston.BlockLogicPistonBaseSticky;
+import net.minecraft.core.block.piston.PistonCommon;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
@@ -16,6 +15,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.block.*;
@@ -802,20 +802,38 @@ public final class Blocks {
     public static final @NotNull Block<BlockLogicRepeater> REPEATER_ACTIVE = register("repeater.active", "minecraft:block/repeater_active", 511, (BlockLogicSupplier<BlockLogicRepeater>)b -> new BlockLogicRepeater(b, true))
         .withSound(BlockSounds.STONE).withHardness(0.0F).withLightEmission(0.625F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.redstone).setStatParent(() -> REPEATER_IDLE)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final @NotNull Block<BlockLogicTimer> TIMER = register("timer", "minecraft:block/timer", 512, BlockLogicTimer::new)
+        .withSound(BlockSounds.STONE).withHardness(0.0F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.redstone).setStatParent(() -> Items.TIMER)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS);
 
-    public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE = register("piston.base", "minecraft:block/piston_base", 520, (BlockLogicSupplier<BlockLogicPistonBase>)b -> new BlockLogicPistonBase(b, 12))
+    public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE = register("piston.base", "minecraft:block/piston_base", 520, (BlockLogicSupplier<BlockLogicPistonBase>)b -> 
+        new BlockLogicPistonBase(
+            b, PistonCommon.TYPE_NORMAL,
+            (byte)12, (byte)1, EnumDropCause.SILK_TOUCH, false, Double.NaN
+        ))
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE_STICKY = register("piston.base.sticky", "minecraft:block/piston_base_sticky", 521, (BlockLogicSupplier<BlockLogicPistonBase>)b -> new BlockLogicPistonBaseSticky(b, 12))
+    public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE_STICKY = register("piston.base.sticky", "minecraft:block/piston_base_sticky", 521, (BlockLogicSupplier<BlockLogicPistonBase>)b -> 
+        new BlockLogicPistonBase(
+            b, PistonCommon.TYPE_STICKY,
+            (byte)12, (byte)1, null, true, Double.NaN
+        ))
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+
     public static final @NotNull Block<BlockLogicPistonHead> PISTON_HEAD = register("piston.head", "minecraft:block/piston_head", 522, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 4/16d, 4/16d))
         .withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats().withImmovableFlagSet()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+
     public static final @NotNull Block<BlockLogicPistonMoving> PISTON_MOVING = register("piston.moving", "minecraft:block/piston_moving", 523, BlockLogicPistonMoving::new)
         .withSound(BlockSounds.STONE).withDisabledStats()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU);
-    public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE_STEEL = register("piston.base.steel", "minecraft:block/piston_base_steel", 524, (BlockLogicSupplier<BlockLogicPistonBase>)b -> new BlockLogicPistonBaseSteel(b, 24))
+
+    public static final @NotNull Block<BlockLogicPistonBase> PISTON_BASE_STEEL = register("piston.base.steel", "minecraft:block/piston_base_steel", 524, (BlockLogicSupplier<BlockLogicPistonBase>)b -> 
+        new BlockLogicPistonBase(
+            b, PistonCommon.TYPE_STEEL,
+            (byte)24, (byte)1, EnumDropCause.PISTON_CRUSH, false, 2.0
+        ))
         .withSound(BlockSounds.METAL)
         .withHardness(5F)
         .withBlastResistance(2000F)
